*+
*+
*+    Source Module => MULTITSK.PRG
*+
*+    Functions: Function WhileReader()
*+               Static Function KeyPoller()
*+
*+    Reformatted by Click! 1.13b3 on May-25-1998 at  2:06 pm
*+
*+

#include "getexit.ch"
#include "reader.ch"

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Function......WhileReader
// Purpose.......Is a replacement reader for Clipper Get System. It will
//               allow for a WHILE clause in the a Clipper "@ ... GET" command
//               as in: "@ ... GET <var> WHILE <udf>.  See READER.CH for
//               command syntax.  Uses include KeyPoller() function.
//
// Author........Mark Cooperstein
// Parameter.....oGet (GET object).
// Returns.......NIL
// Date..........August 15,1992
// Parameters....None
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

*+
*+
*+    Function WhileReader()
*+
*+
*+
function WhileReader( oGet )

local nKey := 0

if GetPreValidate( oGet )
   oGet:SetFocus()

   do while oGet:exitState == GE_NOEXIT

      if oGet:typeOut
         oGet:exitState := GE_ENTER
      endif

      do while oGet:exitState == GE_NOEXIT
         if .not. ( nKey := KeyPoller( oGet ) ) == 0
            GetApplyKey( oGet, nKey )
         endif
      enddo

      if .not. GetPostValidate( oGet )
         oGet:exitState := GE_NOEXIT
      endif

   enddo

   oGet:KillFocus()

endif

return NIL

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Function......KeyPoller
// Purpose.......Called from WhileReader(). It uses an Inkey() within a
//                   DO WHILE loop. After checking Inkey(), it will eval()
//      the user function (if specified) to execute the
//                   "WHILE  <udf>" clause of the modified GET system.
// Parameter.....oGet (get object).
// Returns.......nKey (int) value returned from inkey() from keyboard read.
//
// Author........Mark Cooperstein
// Date..........August 15, 1992
// Parameters....None
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

*+
*+
*+    Static Function KeyPoller()
*+
*+    Called from ( multitsk.prg )   1 - function whilereader()
*+
*+
*+
static function KeyPoller( oGet )

local nKey := 0

do while nKey == 0
   nKey := inkey()
   eval( oGet:cargo )
   devpos( oGet:Row, oGet:Col + oGet:pos - 1 )
enddo

if nKey == 0
   oGet:exitState := GE_ESCAPE
endif

return ( nKey )

*+ EOF: MULTITSK.PRG
