//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
// Program.....: READER.CH
//
// Version.....: 2.0
//
// Date........: August 15, 1992
//
// Programmer..: Mark Cooperstein
//
// Purpose.....: Contains command definitions replace the "@ ... GET" command
//               found in the standard GET system. It allows you to add
//               a WHILE <udf> clause to the "@ ... GET" command.
//               This CH file must be included in any Clipper program that
//               needs this functionality, as well as the functions found in
//               multitsk.prg.
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#command @ <row>, <col> GET <var>                           ;
            [PICTURE <pic>]                                 ;
            [VALID <valid>]                        			;
            [WHEN <when>]                            		;
            [WHILE <while>]                          		;
    =>                                                      ;
   SetPos( <row>, <col> )                            		; ;
   AAdd(GetList, _GET_( <var>, <(var)>, <pic>, <{valid}>, <{when}> ):display()) ; ;
   [ ATail(GetList):reader := {|get|WhileReader(get)}       ; ;
   Atail(GetList):cargo := &('{||' + <(while)> + '}')]


#command @ <row>,<col> say  <sayxpr>                        ;
   [<sayclauses,...>]                                       ;
   GET <var>                                           		;
   [<getclauses,...> ]                                 		;
   [WHILE <while>]                                     		;
   [COLOR <getcolor>]                                  		;
    =>                                                      ;
   @ <row>,<col> say <sayxpr> [<sayclauses>]                ; ;
   @ Row(),Col()+1 GET <var> [<getclauses>] [WHILE <while>] [COLOR <getcolor>]

